; Michal Turek, ctvrtek 16:15



; Zkopiruje dva retezce z pameti programu do pameti dat a pak je spoji do jednoho
start:
	jmp loadstr1		; skok na program

str_1: .db "prvni", 0	; prvni retezec
str_2: .db "druhy", 0	; druhy retezec

	.dseg			; segment s daty
	.org 0x100

str_1c: .byte 10	; misto pro ulozeni prvniho
str_2c: .byte 10	; misto pro ulozeni druheho
str:    .byte 20	; misto pro ulozeni spojenych
	

	.cseg			; segment s programem

;;;;; kopirovani prvniho
loadstr1:
	ldi r30, low(str_1<<1)	; inicializace ukazatelu do pameti
	ldi r31, high(str_1<<1)
	ldi r28, low(str_1c)
	ldi r29, high(str_1c)

cp_cycle1:
	lpm				; do r0 nakopiruje data z pameti programu
	st Y+, r0		; do dat nakopiruje obsah r0
	adiw r30, 1		; pricte cislo do registrovyho paru ( R(d+1):Rd <- R(d+1):Rd + K )
	tst r0			; test jestli je to nula
	brne cp_cycle1	; skok pokud neni



;;;;; kopirovani druhyho
loadstr2:
	ldi r30, low(str_2<<1)	; inicializace ukazatelu do pameti
	ldi r31, high(str_2<<1)
	ldi r28, low(str_2c)
	ldi r29, high(str_2c)

cp_cycle2:
	lpm				; do r0 nakopiruje data z pameti programu
	st Y+, r0		; do dat nakopiruje obsah r0
	adiw r30, 1		; pricte cislo do registrovyho paru ( R(d+1):Rd <- R(d+1):Rd + K )
	tst r0			; test jestli je to nula
	brne cp_cycle2	; skok pokud neni



;;;;; spojovani
	ldi r30, low(str_1c)	; inicializace ukazatelu do pameti
	ldi r31, high(str_1c)
	ldi r28, low(str)
	ldi r29, high(str)

cycle_3:
	ld	r0, Z+		; z pameti dat zkopiruje do r0
	tst r0			; test, jestli je to ukoncovaci nula
	breq done		; jestli jo, skok pryc
	st Y+, r0		; ulo hodnotu z r0 na adresu Y
	jmp cycle_3		; while(... != 0)

done:
	ldi r30, low(str_2c)	; adresa
	ldi r31, high(str_2c)

cycle4:
	ld r0, Z+		; z pameti dat zkopiruje do r0
	st Y+, r0		; ulo hodnotu z r0 na adresu Y
	tst r0			; test, jestli je to ukoncovaci nula
	brne cycle4		; pokud neni, opakovat


end:
	rjmp end


