// Michal Turek
// cviceni ctvrtek, 16:15

/**********************************************************

  Funkce void student() v assembleru.

  Tento zdrojovy kod obsahuje nezbytnou
  cast implementace funkce student(), ktera bude
  prilinkovana k main.c. V casti "... zde doplnte ..."
  muze student dopsat jakekoliv FP instrukce podle
  zadaneho ukolu.

  Jmena registru musi vzdy zacinat znakem %.
  napr. fld %st(0)

  Pro vytisknuti vysledku, ktery je na vrcholu zasobniku,
  pouzijte instrukci call PRINTST0.

  Pro ladeni programu muzete vyuzit instrukci
  call FPDUMPx, kde x je cislo v rozsahu 1-9.
  Napr. instrukci call FPDUMP1 se vytiskne kompletni stav
  FP jednotky vcetne obsahu celeho zasobniku.

  Pro kazdy bod vypisu stavu FP jednotky pouzijte
  instrukci s jinym cislem. Napr. call FPDUMP1,
  call FPDUMP2, atd. Cislo najdete v hlavicce
  kazdeho vypisu, tak budete vedet k jakemu bodu
  v programu patri ktery vypis.

  Pozor ! V prostredi CYGWIN musi kazdy symbol, ktery ma
  vazbu na main.c zacinat podtrzitkem. Napr. _student,
  _FPDUMP1, _PRINTST0, atd. V Linuxu toto neni potreba.

***********************************************************
*/

	.file   "student.asm"
      .text

.global student

x: .tfloat 0.5
trifact: .tfloat 6.0
petfact: .tfloat 120.0
sedmfact: .tfloat 5040.0

student:
	/* prologue */
        pushl   %ebp
        movl    %esp, %ebp

	// ... zde doplnte vlastni instrukce ...

// ctvrtej
    fldt x
    fld %st(0)
    fmul %st(1)
    fmul %st(1)
    fmul %st(1)
    fmul %st(1)
    fmul %st(1)
    fmul %st(1)
    fxch
    fstp %st(0)
    
    fldt sedmfact
    fxch
    fdiv %st(1)
    fxch
    fstp %st(0)
    
// treti
    fldt x
    fld %st(0)
    fmul %st(1)
    fmul %st(1)
    fmul %st(1)
    fmul %st(1)
    fxch
    fstp %st(0)
    
    fldt petfact
    fxch
    fdiv %st(1)
    fxch
    fstp %st(0)
    
// odecteni treti-ctvrty
    fsub %st(1)
    fxch
    fstp %st(0)
    
// druhy
    fldt x
    fld %st(0)
    fmul %st(1)
    fmul %st(1)
    fxch
    fstp %st(0)
    
    fldt trifact
    fxch
    fdiv %st(1)
    fxch
    fstp %st(0)
    
// prvni
    fldt x
    
// odecteni prvni-druhy
    fsub %st(1)
    fxch
    fstp %st(0)
    
// zaverecny secteni
    fadd %st(1)
    fxch
    fstp %st(0)
    
    

//	call PRINTST0
	call FPDUMP1

	/* epilogue */
	leave
      ret
